/*!
  @file rx_stl.h
	
  @brief STL File Input/Output
 
  @author Makoto Fujisawa
  @date   2011
*/

#ifndef _RX_STL_H_
#define _RX_STL_H_


//-----------------------------------------------------------------------------
// Include Files
//-----------------------------------------------------------------------------
#include "rx_mesh.h"

//-----------------------------------------------------------------------------
// Name Space
//-----------------------------------------------------------------------------
using namespace std;


//-----------------------------------------------------------------------------
// rxSTLNX̐錾 - STL`̓ǂݍ
//-----------------------------------------------------------------------------
class rxSTL
{
public:
	//! RXgN^
	rxSTL();
	//! fXgN^
	~rxSTL();

	/*!
	 * STLt@Cǂݍ
	 * @param[in] file_name t@C(tpX)
	 * @param[out] vrts _W
	 * @param[out] vnms _@
	 * @param[out] poly |S
	 * @param[in] vertex_integration _tO
	 * @param[in] vertex_normal _@vZtO
	 */
	bool Read(string file_name, vector<Vec3> &vrts, vector<Vec3> &vnms, vector<rxFace> &plys, 
			  bool vertex_integration = true, bool vertex_normal = true);

	/*!
	 * STLt@C()
	 * @param[in] file_name t@C(tpX)
	 * @param[in] vrts _W
	 * @param[in] plys |S
	 * @param[in] binary oCitH[}bgł̕ۑtO
	 */
	bool Save(string file_name, const vector<Vec3> &vrts, const vector<rxFace> &plys, 
			  bool binary = false);

protected:
	//! ASCIItH[}bgSTLt@Cǂݍ
	bool readAsciiData(ifstream &file, vector<Vec3> &vrts, vector<Vec3> &vnms, vector<rxFace> &plys);

	//! oCitH[}bgSTLt@Cǂݍ
	bool readBinaryData(ifstream &file, vector<Vec3> &vrts, vector<Vec3> &vnms, vector<rxFace> &plys);

	//! ASCIItH[}bgSTLt@Cǂݍ
	bool saveAsciiData(ofstream &file, const vector<Vec3> &vrts, const vector<rxFace> &plys);

	//! oCitH[}bgSTLt@Cǂݍ
	bool saveBinaryData(ofstream &file, const vector<Vec3> &vrts, const vector<rxFace> &plys);

};



#endif // _RX_OBJ_H_
