/*!
  @file rx_vrml.h

  @brief VRML Input/Output
	- ShapeIndexedFaceSet̂ݑΉ

  @author Makoto Fujisawa
  @date   2011
*/

#ifndef _RX_VRML_H_
#define _RX_VRML_H_


//-----------------------------------------------------------------------------
// Include Files
//-----------------------------------------------------------------------------
#include "rx_mesh.h"

//-----------------------------------------------------------------------------
// Name Space
//-----------------------------------------------------------------------------
using namespace std;


//-----------------------------------------------------------------------------
// VRMLNX̐錾 - VRML`̓ǂݍ
//-----------------------------------------------------------------------------
class rxVRML
{
public:
	//! RXgN^
	rxVRML();
	//! fXgN^
	~rxVRML();

	/*!
	 * VRMLt@Cǂݍ
	 * @param[in] file_name t@C(tpX)
	 * @param[out] vrts _W
	 * @param[out] vnms _@
	 * @param[out] poly |S
	 * @param[out] mats ގ
	 * @param[in] triangle |S̎Op`tO
	 */
	bool Read(string file_name, vector<Vec3> &vrts, vector<Vec3> &vnms, vector<rxFace> &plys, rxMTL &mats, bool tri = true);

	/*!
	 * VRMLt@C
	 * @param[in] file_name t@C(tpX)
	 * @param[in] vrts _W
	 * @param[in] vnms _@
	 * @param[in] plys |S
	 * @param[in] mats ގ
	 */
	bool Save(string file_name, const vector<Vec3> &vrts, const vector<Vec3> &vnms, const vector<rxFace> &plys, const rxMTL &mats);

};




#endif // _RX_VRML_H_
